/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.statistik;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.statistik.boundary.AbstractStatistikKennzeichenSearchParameters;
import de.ivu.elect.business.statistik.boundary.StatistikKennzeichenChangeEvent;
import de.ivu.elect.business.statistik.boundary.StatistikKennzeichenConversationStore;
import de.ivu.elect.business.statistik.boundary.StatistikKennzeichenExtendedDAO;
import de.ivu.elect.business.statistik.boundary.StatistikKennzeichenSearch;
import de.ivu.elect.business.statistik.boundary.StatistikKennzeichenSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.statistik.entity.StatistikKennzeichen;
import de.ivu.elect.business.statistik.entity.StatistikKennzeichenMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStatistikKennzeichenSearchView.COMPONENT_NAME)
@View(viewId = AbstractStatistikKennzeichenSearchView.VIEW_ID, useCase = UseCasePermission.STATISTIK_KENNZEICHEN_SEARCH)
public abstract class AbstractStatistikKennzeichenSearchView extends AbstractElectSearchView<StatistikKennzeichen> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "statistikKennzeichenSearchView";
  
  public static final String VIEW_ID = "/statistik/statistik-kennzeichen-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStatistikKennzeichenSearchView requestHandler;

  @Inject
  private transient StatistikKennzeichenExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StatistikKennzeichenConversationStore.class)
  protected transient StatistikKennzeichenConversationStore conversationStore;

  @Inject
  protected transient StatistikKennzeichenSearch search;

  @Inject
  @ConversationGroup(AbstractStatistikKennzeichenSearchParameters.class)
  protected transient StatistikKennzeichenSearchParameters searchParameters;

  @Inject
  protected transient StatistikKennzeichenMeta entityMeta;

  public AbstractStatistikKennzeichenSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public StatistikKennzeichen getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(StatistikKennzeichen entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StatistikKennzeichenSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<StatistikKennzeichen> getEagerLoadingCollector() {
    return EagerLoadingCollector.<StatistikKennzeichen> create();
  }

  @Override
  public List<StatistikKennzeichen> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<StatistikKennzeichen> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStatistikKennzeichenChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StatistikKennzeichenChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStatistikKennzeichenSearchView {

    @View
    @Inject
    private transient Instance<AbstractStatistikKennzeichenSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStatistikKennzeichenSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
